/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.ParamConexion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderParamConexion;

/**
 * 
 * @author Gleimar
 */
@Controller("busquedaParamConexionController")
@Scope("prototype")
public class BusquedaParamConexionController extends MyGenericForwardComposer {

	@Autowired
	private transient PagedListWrapper<ParamConexion> plwParamConexion;
	private MyListbox paramConexionList;
	private Paging pagingParamConexion;
	private Textbox txtNombre;

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPametro(new ParamConexion());
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		paramConexionList.setItemRenderer(new RenderParamConexion());
		paramConexionList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				ParamConexion c = (ParamConexion) paramConexionList.getSelected();
				verPametro(c);
			}
		});

		refreshLista();

		txtNombre.focus();
	}

	private void verPametro(ParamConexion c) {
		if (c == null) {
			return;
		}

		Map args = new HashMap();
		args.put("paramConexion", c);
		args.put("paramConexionList", paramConexionList);

		openWindow("/gui/esquema_operacional/editarParamConexion.zul",
				Labels.getLabel("editarParamConexionController.window.title"), args, MODAL);
	}

	private void refreshLista() throws InterruptedException {
		HibernateSearchObject<ParamConexion> paramConexionSearch =
				new HibernateSearchObject<ParamConexion>(ParamConexion.class, pagingParamConexion.getPageSize());

		paramConexionSearch.addFilterLike("descparametro", "%" + txtNombre.getText().trim().concat("%"));
		paramConexionSearch.addFilterEqual("activo", Boolean.TRUE);
		paramConexionSearch.addSortAsc("nombparametro");

		plwParamConexion.init(paramConexionSearch, paramConexionList, pagingParamConexion);

		if (paramConexionList.getData().length == 0) {

			Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
					Labels.getLabel("busquedaParamConexionController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

		}
	}
}
